%global commit c1b839a043c606234610fb5eea201d0487a3b928
%global shortcommit %(c=%{commit}; echo ${c:0:7})
Name:           ultimaker-marlin-firmware
Version:        13.03
Release:        1%{?dist}
Summary:        Ultimaker firmware for the 3D printer
#this uses the arduino cross-compiler, so the output is arch-independent
BuildArch:      noarch
License:        GPLv3+
URL:            https://github.com/Ultimaker/Marlin
Source0:        https://github.com/Ultimaker/Marlin/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
BuildRequires:  ino
BuildRequires:  dos2unix

%description
%{summary}.

%global platform mega2560

%prep
%setup -qn Marlin-%{commit}

# make the directory structure like ino likes it
mv Marlin src
mkdir lib

# Prepare the build variants
# This is a bit dirty, but as far as I know ino doesn't support redefining things
cd src
for E in 1 2; do
  for B in 250000 115200; do
    configuration=Configuration.h.$B-$E
    configuration_adv=Configuration_adv.h.$B-$E
    cp Configuration.h $configuration
    cp Configuration_adv.h $configuration_adv
    sed -i 's/#define VERSION_PROFILE "Github checkout"/#define VERSION_PROFILE "'$B-$E'"/' $configuration
    [ $B -eq 115200 ] && \
    sed -i 's/#define BAUDRATE 250000/#define BAUDRATE 115200/' $configuration
    [ $E -eq 2 ] && \
    sed -i 's/#define TEMP_SENSOR_1 0/#define TEMP_SENSOR_1 -1/' $configuration && \
    sed -i 's/#define EXTRUDERS 1/#define EXTRUDERS 2/' $configuration_adv
  done
done

cd -

iconv -f iso8859-1 -t utf-8 src/COPYING > src/COPYING.conv && mv -f src/COPYING.conv src/COPYING
dos2unix README.md

%build
for E in 1 2; do
  for B in 250000 115200; do
    echo "Building for $E extruders with $B baudrate..."
    configuration=Configuration.h.$B-$E
    configuration_adv=Configuration_adv.h.$B-$E
    cp -f src/$configuration src/Configuration.h
    cp -f src/$configuration_adv src/Configuration_adv.h
    ino build -m %{platform}
    mv .build/%{platform}/firmware.hex firmware-$B-$E.hex
    rm -rf .build
  done
done

%install
install -Dpm0644 firmware-115200-1.hex %{buildroot}%{_datadir}/%{name}/MarlinUltimaker-115200.hex
install -Dpm0644 firmware-250000-1.hex %{buildroot}%{_datadir}/%{name}/MarlinUltimaker-250000.hex
install -Dpm0644 firmware-115200-2.hex %{buildroot}%{_datadir}/%{name}/MarlinUltimaker-115200-dual.hex
install -Dpm0644 firmware-250000-2.hex %{buildroot}%{_datadir}/%{name}/MarlinUltimaker-250000-dual.hex

%files
%{_datadir}/%{name}
%doc src/COPYING README.md

%changelog
* Wed Oct 16 2013 Miro Hrončok <mhroncok@redhat.com> - 13.03-1
- New release
- Also build for multiple (two) extruders
- Write the information about the build into VERSION_PROFILE
- Build for mega2560
- Use forloops for preparing config and build

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12.12-0.6.RC1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Apr 20 2013 Miro Hrončok <mhroncok@redhat.com> - 12.12-0.5.RC1
- Filename changes

* Sat Apr 20 2013 Miro Hrončok <mhroncok@redhat.com> - 12.12-0.4.RC1
- Include both 115200 and 250000 baudrates

* Mon Feb 18 2013 Miro Hrončok <mhroncok@redhat.com> - 12.12-0.3.RC1
- COPYING is now utf-8
- dos2unix README.md

* Sun Jan 27 2013 Miro Hrončok <mhroncok@redhat.com> - 12.12-0.2.RC1
- Updated source to follow GitHub rule

* Tue Jan 22 2013 T.C. Hollingsworth <tchollingsworth@gmail.com> - 12.12-0.1.RC1
- rough initial package
